Unit CharSet;

{  뢮   ⮬ ࠧࠧ ᥩ}

interface

uses Crt,Graph;

const
  CHAR_WDT = 8; {ਭ ᨬ}
  CHAR_HGT = 8; { ᨬ}

  Procedure LoadCharSet (FileName : string);
  {
    㦠   
  }
  Procedure FreeCharSet;
  {
    稢 ࠡ, ᢮ 
  }
  Procedure SetCharStyle (bDelta, bWidth, bKAngle : integer);
  {
    ⠭ ⨯ 뢮 ᨬ :
      Delta  - ﭨ  뢮묨 ᥫ
                 (᫨ 0,  ᯮ㥬 אַ 뢮   
                  ᪮७ ࠡ)
      Width  - ࠧ ᥫ ( ᥫ !?!?)
      KAngle - 樥  (ᬥ饭 KAngle ᥫ  ப)
  }
  Procedure WriteString (x, y, color : integer; bstring : string);
  {
    뢮 ப  ࠭
       x -  ,  y -  ᥫ
  }
  Function  GetStringWidth (st : string) : integer;
  {
      㭪 頥  ப  ᥫ !
  }
  Function  GetStringHeight (st : string) : integer;
  {
      㭪 -  ப !
  }

implementation

type
  BCharData     = array [1..CHAR_HGT] of Byte;

  BCharArray    = array [0..255] of BCharData;
  BCharArrayPtr = ^BCharArray;

var
  CharArrayPtr  : BCharArrayPtr;
  Delta, Width  : integer;
  Blur          : boolean;
  KAngle        : integer;

procedure LoadCharSet (FileName : string);
var
  f : file of BCharArray;
begin
  Assign (f, FileName);
  Reset (f);
  New (CharArrayPtr);
  Read (f, CharArrayPtr^)
end;

procedure FreeCharSet;
begin
  Dispose (CharArrayPtr)
end;

procedure SetCharStyle (bDelta, bWidth, bKAngle : integer);
begin
  Delta   := bDelta;
  Width   := bWidth;
  KAngle  := bKAngle
end;

procedure WriteChar (x, y, color : integer; bchar : char);
var
  i, j     : integer;
  bx, by   : integer;
  n        : byte;
begin
  for i := 1 to 8 do begin
    n := CharArrayPtr^ [ord (bchar), i];
    for j := 1 to 8 do
      if n and (256 shr j) <> 0 then begin
        bx := x+(j-1)*Delta-(i-9)*KAngle;
        by := y+(i-1)*Delta;
        SetFillStyle (SolidFill, Color);
        Bar (bx, by, bx+Width, by+Width)
      end
  end
end;

procedure HardWriteChar (x, y : integer; color : byte; bchar : char);
var
  aofs, aseg : word;
begin
  aofs := OFS (CharArrayPtr^);
  aseg := SEG (CharArrayPtr^);
  {
      譮,   ᬮ !
  }
    asm
      push ds
      mov ds, aseg
      mov ax, $A000
      mov es, ax
      mov bx, y
      mov cl, 4
      shl bx, cl
      mov dx, bx
      mov cl, 2
      shl bx, cl
      add bx, dx
      add bx, x
      mov dx, $3CE
      mov al, 5
      out dx, al
      inc dx
      mov al, 2
      out dx, al
      mov dx, $3CE
      mov al, 3
      out dx, al
      inc dx
      mov al, $38
      out dx, al
      mov si, aofs
      mov ax, ax
      mov al, bchar
      shl ax, 3
      add si, ax
      mov cx, 8
   @0:mov dx, $3CE
      mov al, 8
      out dx, al
      inc dx
      mov al, [si]
      out dx, al
      mov al, es:[bx]
      mov al, color
      mov es:[bx], al
      add bx, 80
      inc si
      loop @0
      pop ds
    end
end;

procedure WriteString (x, y, color : integer; bstring : string);
var
  i : integer;
begin
  for i := 1 to Length (bstring) do
    if Delta = 0 then
      HardWriteChar (x div 8+i-1, y, color, bstring [i])
    else
      WriteChar (x+(i-1)*CHAR_WDT*Delta, y, color, bstring [i]);
  {
    ⠭ ०  0  ४⭮
    ࠡ  쭥襬...
  }
  asm
    mov dx, $3CE
    mov al, 5
    out dx, al
    inc dx
    mov al, 0
    out dx, al
    mov dx, $3CE
    mov al, 3
    out dx, al
    inc dx
    mov al, 0
    out dx, al
  end
end;

function GetStringWidth (st : string) : integer;
begin
  if Delta = 0 then
    GetStringWidth := Length (st) * CHAR_WDT
  else
    GetStringWidth := Length (st) * CHAR_WDT*Delta + KAngle*CHAR_WDT
end;

function GetStringHeight (st : string) : integer;
begin
  if Delta = 0 then
    GetStringHeight := CHAR_HGT
  else
    GetStringHeight := CHAR_HGT*Delta
end;

begin
  {
    砫 ⠭窨 !
  }
  Delta   := 0;
  Width   := 0;
  KAngle  := 0
end.
