unit Syncron;

interface

const
  TimerFreq = 1193182;

type
  Proc = Procedure;

procedure Delay (n : longint);
procedure Wait (n : longint);
procedure SyncroInit (NCounts : word);

function GetTime : longint;
function Syncro (Count, Draw : Proc) : boolean;

var
  CPS    : longint;
  NCount : longint;
  NDraw  : longint;

implementation

var
  CountTime : longint;
  DrawTime  : longint;
  FrameTime : longint;
  RestTime  : longint;
  FreeTime  : longint;

function GetTime; assembler;
asm
       cli
       mov   dx, 20h
       mov   al, 0Ah
       out   dx, al
       mov   al, 00h
       out   43h, al
       in    al, dx
       mov   di, ax
       in    al, 40h
       mov   bl, al
       in    al, 40h
       mov   bh, al
       not   bx
       in    al, 21h
       mov   si, ax
       mov   al, 0FFh
       out   21h, al
       mov   es, Seg0040
       mov   dx, es:[6Ch]
       mov   ax, si
       out   21h, al
       sti
       mov   ax, di
       test  al, 01h
       jz    @1
       cmp   bx, 0FFh
       ja    @1
       inc dx
  @1 : mov ax,bx
end;

procedure Wait (n : longint);
var
  Time : longint;
begin
  Time := GetTime + n;
  while GetTime < Time do
end;

procedure Delay (n : longint);
begin
  Wait (n * 1000)
end;

procedure SyncroInit (NCounts : word);
begin
  CPS       := NCounts;
  RestTime  := 0;
  DrawTime  := 0;
  NCount    := 0;
  NDraw     := 0;
  FrameTime := TimerFreq div CPS
end;

function Syncro (Count, Draw : Proc) : boolean;
var
  tmp : longint;
begin
  CountTime := GetTime;
  Count;
  Inc (NCount);
  tmp       := GetTime;
  CountTime := tmp - CountTime;
  Inc (RestTime, FrameTime-CountTime);
  if RestTime >= DrawTime then begin
    Draw;
    Inc (NDraw);
    DrawTime := GetTime - tmp;
    FreeTime := FrameTime - CountTime - DrawTime;
    if FreeTime > 0 then begin
      Wait (FreeTime);
      Dec (RestTime, FreeTime)
    end;
    Dec (RestTime, DrawTime)
  end;
  Syncro := CountTime < FrameTime
end;

begin
  asm
         mov   al, 34h
         out   43h, al
         xor   al, al
         out   40h, al
         out   40h, al
  end
end.
